/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third argument to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx gen_split_44 (rtx, rtx *);
extern rtx gen_split_45 (rtx, rtx *);



static int
recog_1 (rtx x0 ATTRIBUTE_UNUSED,
	rtx insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      goto L244;
    case QImode:
      goto L247;
    case HImode:
      goto L248;
    case CCmode:
      goto L249;
    default:
      break;
    }
 L118: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == PC)
    goto L225;
  if (register_operand (x1, VOIDmode))
    {
      operands[0] = x1;
      goto L213;
    }
  goto ret0;

 L244: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == MEM)
    goto L76;
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L3;
    }
 L245: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L81;
    }
 L246: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L86;
    }
  goto L118;

 L76: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == PRE_DEC)
    goto L77;
  goto L246;

 L77: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 1)
    goto L78;
  goto L246;

 L78: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      return 17;  /* movsi_push */
    }
  x1 = XEXP (x0, 0);
  goto L246;

 L3: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L250;
  x1 = XEXP (x0, 0);
  goto L245;

 L250: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L4;
    case MINUS:
      goto L9;
    case MULT:
      goto L14;
    case DIV:
      goto L19;
    case UDIV:
      goto L24;
    case MOD:
      goto L29;
    case UMOD:
      goto L34;
    case NEG:
      goto L39;
    case NOT:
      goto L43;
    case AND:
      goto L47;
    case XOR:
      goto L52;
    case IOR:
      goto L57;
    case ASHIFT:
      goto L62;
    case ASHIFTRT:
      goto L67;
    case LSHIFTRT:
      goto L72;
    case ZERO_EXTEND:
      goto L91;
    case SIGN_EXTEND:
      goto L99;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L245;

 L4: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L5;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L5: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (moxie_add_operand (x2, SImode))
    {
      operands[2] = x2;
      return 2;  /* addsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L9: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L10;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L10: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (moxie_sub_operand (x2, SImode))
    {
      operands[2] = x2;
      return 3;  /* subsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L14: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L15;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L15: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 4;  /* mulsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L19: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L20;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L20: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 5;  /* divsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L24: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L25;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L25: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 6;  /* udivsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L29: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L30;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L30: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 7;  /* modsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L34: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L35;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L35: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 8;  /* umodsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L39: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 9;  /* negsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L43: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 10;  /* one_cmplsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L47: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L48;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L48: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 11;  /* andsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L52: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L53;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L53: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 12;  /* xorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L57: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L58;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L58: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 13;  /* iorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L62: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L63;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L63: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 14;  /* ashlsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L67: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L68;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L68: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 15;  /* ashrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L72: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L73;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L73: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 16;  /* lshrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L91: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L267;
    case HImode:
      goto L268;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L267: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[1] = x2;
      return 20;  /* zero_extendqisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L268: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[1] = x2;
      return 21;  /* zero_extendhisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L99: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L269;
    case HImode:
      goto L270;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L269: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[1] = x2;
      return 22;  /* extendqisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L270: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[1] = x2;
      return 23;  /* extendhisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L245;

 L81: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == MEM)
    goto L82;
  x1 = XEXP (x0, 0);
  goto L246;

 L82: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == POST_INC)
    goto L83;
  x1 = XEXP (x0, 0);
  goto L246;

 L83: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      return 18;  /* movsi_pop */
    }
  x1 = XEXP (x0, 0);
  goto L246;

 L86: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L87;
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L87: ATTRIBUTE_UNUSED_LABEL
  if (
#line 228 "../../gcc/config/moxie/moxie.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)))
    {
      return 19;  /* *movsi */
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L247: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L106;
    }
  goto L118;

 L106: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, QImode))
    {
      operands[1] = x1;
      goto L107;
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L107: ATTRIBUTE_UNUSED_LABEL
  if (
#line 306 "../../gcc/config/moxie/moxie.md"
(register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode)))
    {
      return 24;  /* *movqi */
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L248: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L110;
    }
  goto L118;

 L110: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L111;
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L111: ATTRIBUTE_UNUSED_LABEL
  if (
#line 334 "../../gcc/config/moxie/moxie.md"
((register_operand (operands[0], HImode)
    || register_operand (operands[1], HImode))))
    {
      return 25;  /* *movhi */
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L249: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == REG
      && XINT (x1, 0) == 11)
    goto L114;
  goto L118;

 L114: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == COMPARE)
    goto L115;
  x1 = XEXP (x0, 0);
  goto L118;

 L115: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L116;
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L116: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 26;  /* *cmpsi */
    }
  x1 = XEXP (x0, 0);
  goto L118;

 L225: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      return 40;  /* indirect_jump */
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L120;
    case LABEL_REF:
      goto L229;
    default:
     break;
   }
  goto ret0;

 L120: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case NE:
      goto L121;
    case EQ:
      goto L130;
    case LT:
      goto L139;
    case LTU:
      goto L148;
    case GT:
      goto L157;
    case GTU:
      goto L166;
    case GE:
      goto L175;
    case LE:
      goto L184;
    case GEU:
      goto L193;
    case LEU:
      goto L202;
    default:
     break;
   }
  goto ret0;

 L121: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L122;
  goto ret0;

 L122: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L123;
  goto ret0;

 L123: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L124;
  goto ret0;

 L124: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L125;

 L125: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 27;  /* *bne */
    }
  goto ret0;

 L130: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L131;
  goto ret0;

 L131: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L132;
  goto ret0;

 L132: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L133;
  goto ret0;

 L133: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L134;

 L134: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 28;  /* *beq */
    }
  goto ret0;

 L139: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L140;
  goto ret0;

 L140: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L141;
  goto ret0;

 L141: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L142;
  goto ret0;

 L142: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L143;

 L143: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 29;  /* *blt */
    }
  goto ret0;

 L148: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L149;
  goto ret0;

 L149: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L150;
  goto ret0;

 L150: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L151;
  goto ret0;

 L151: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L152;

 L152: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 30;  /* *bltu */
    }
  goto ret0;

 L157: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L158;
  goto ret0;

 L158: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L159;
  goto ret0;

 L159: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L160;
  goto ret0;

 L160: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L161;

 L161: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 31;  /* *bgt */
    }
  goto ret0;

 L166: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L167;
  goto ret0;

 L167: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L168;
  goto ret0;

 L168: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L169;
  goto ret0;

 L169: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L170;

 L170: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 32;  /* *bgtu */
    }
  goto ret0;

 L175: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L176;
  goto ret0;

 L176: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L177;
  goto ret0;

 L177: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L178;
  goto ret0;

 L178: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L179;

 L179: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 33;  /* *bge */
    }
  goto ret0;

 L184: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L185;
  goto ret0;

 L185: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L186;
  goto ret0;

 L186: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L187;
  goto ret0;

 L187: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L188;

 L188: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 34;  /* *ble */
    }
  goto ret0;

 L193: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L194;
  goto ret0;

 L194: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L195;
  goto ret0;

 L195: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L196;
  goto ret0;

 L196: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L197;

 L197: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 35;  /* *bgeu */
    }
  goto ret0;

 L202: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L203;
  goto ret0;

 L203: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L204;
  goto ret0;

 L204: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L205;
  goto ret0;

 L205: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L206;

 L206: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 36;  /* *bleu */
    }
  goto ret0;

 L229: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  return 41;  /* jump */

 L213: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL)
    goto L214;
  goto ret0;

 L214: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode
      && GET_CODE (x2) == MEM)
    goto L221;
  goto ret0;

 L221: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L222;
    }
  if (immediate_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L216;
    }
  goto ret0;

 L222: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return 39;  /* *call_value_indirect */

 L216: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return 38;  /* *call_value */
 ret0:
  return -1;
}

int
recog (rtx x0 ATTRIBUTE_UNUSED,
	rtx insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;

  switch (GET_CODE (x0))
    {
    case CONST_INT:
      goto L241;
    case SET:
      goto L2;
    case CALL:
      goto L208;
    case RETURN:
      goto L242;
    default:
     break;
   }
  goto ret0;

 L241: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x0, 0) == 0L)
    {
      return 1;  /* nop */
    }
  goto ret0;

 L2: ATTRIBUTE_UNUSED_LABEL
  return recog_1 (x0, insn, pnum_clobbers);

 L208: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (GET_MODE (x1) == QImode
      && GET_CODE (x1) == MEM)
    goto L209;
  goto ret0;

 L209: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonmemory_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L210;
    }
  goto ret0;

 L210: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  operands[1] = x1;
  return 37;  /* *call */

 L242: ATTRIBUTE_UNUSED_LABEL
  if (
#line 499 "../../gcc/config/moxie/moxie.md"
(reload_completed))
    {
      return 42;  /* returner */
    }
  goto ret0;
 ret0:
  return -1;
}

rtx
split_insns (rtx x0 ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;

  if (GET_CODE (x0) == SET)
    goto L232;
  goto ret0;

 L232: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L233;
    }
  goto ret0;

 L233: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == ZERO_EXTEND)
    goto L234;
  goto ret0;

 L234: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L271;
    case HImode:
      goto L272;
    default:
      break;
    }
  goto ret0;

 L271: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L235;
    }
  goto ret0;

 L235: ATTRIBUTE_UNUSED_LABEL
  if (
#line 251 "../../gcc/config/moxie/moxie.md"
(reload_completed))
    {
      return gen_split_44 (insn, operands);
    }
  goto ret0;

 L272: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L240;
    }
  goto ret0;

 L240: ATTRIBUTE_UNUSED_LABEL
  if (
#line 268 "../../gcc/config/moxie/moxie.md"
(reload_completed))
    {
      return gen_split_45 (insn, operands);
    }
  goto ret0;
 ret0:
  return 0;
}

